package org.mrpdaemon.sec.encfs;

import java.io.IOException;
import java.util.Arrays;

public class EncFSBinaryConfig
{
	private EncFSConfig config;
	private byte[] encodedVolumeKey;
	private byte[] ivSeed;
	private byte[] encryptedVolumeKey;
	private byte[] saltData;

	private EncFSBinaryConfig() { }

	public static EncFSBinaryConfig from(EncFSConfig config)
			throws IOException {
		EncFSBinaryConfig obj = new EncFSBinaryConfig();
		obj.config = config;
		obj.encodedVolumeKey = EncFSBase64.decode(config.getBase64EncodedVolumeKey());
		obj.ivSeed = Arrays.copyOfRange(obj.encodedVolumeKey, 0, 4);
		obj.encryptedVolumeKey = Arrays.copyOfRange(obj.encodedVolumeKey, 4, obj.encodedVolumeKey.length);
		obj.saltData = EncFSBase64.decode(config.getBase64Salt());
		return obj;
	}

	public EncFSConfig getConfig() {
		return config;
	}

	public byte[] getEncodedVolumeKey() {
		return encodedVolumeKey;
	}

	public byte[] getIvSeed() {
		return ivSeed;
	}

	public byte[] getEncryptedVolumeKey() {
		return encryptedVolumeKey;
	}

	public byte[] getSaltData() {
		return saltData;
	}
}
